List Expenses
Retrieve a list of Expense objects.
You can use query parameters to filter, sort, and paginate the results.
You can set the money_decimals query parameter to specify the number of decimal places for money fields.
Examples:
?money_decimals=2will return money values rounded to 2 decimal places.?money_decimals=maxwill return money values with the maximum precision.
Authorizations
API key for authentication. Make sure to include the word apikey, followed by a single space and then your token.
Example: apikey 1234_abcdef
Query Parameters
Filter by Addendum ID. Can be multiple.
Filter by calculation rule type. Can be multiple.
commit- commitovercommit- overcommitstepped- steppedstaged- stagedcommit_hourly-commit_hourly
commit, commit_hourly, overcommit, staged, stepped Filter by client ID. Can be multiple.
-2147483648 <= x <= 2147483647Filter by client's company name (client's name). Case insensitive. Supports partial matches.
Filter by creation date-time.
Returns items created after the specified date-time (ISO 8601/RFC 3339 format, UTC.)
You can specify a date with a time separated by a space, or just a date.
Examples:
&created_after=2025-05-15&created_after=2025-05-15 12:00:00&created_after=2025-05-15T12:00:00Z
Filter by creation date-time.
Returns items created before the specified date-time (ISO 8601/RFC 3339 format, UTC.)
You can specify a date with a time separated by a space, or just a date.
Examples:
&created_before=2025-05-15&created_before=2025-05-15 12:00:00&created_before=2025-05-15T12:00:00Z
Filter by currency char code (e.g. USD, EUR). Can be multiple.
Returns currencies with the specified char code.
Examples:
¤cy_char_code=USD¤cy_char_codeEUR¤cy_char_codeUSD
Available values:
EUR- EuroUSD- US Dollar
Filter by currency ID. Can be multiple.
Returns currencies with the specified ID.
Examples:
¤cy_id=1¤cy_id=1¤cy_id=2
Available values:
1- US Dollar2- Euro
Filter by deleted status.
Returns items based on their deletion status.
true- only deleted itemsfalse- only non-deleted itemsnone- all items (default)
Filter by Discount ID. Can be multiple.
Filter by feature ID. Can be multiple.
Filter by feature name. Case insensitive. Supports partial matches.
Filter by date.
Returns items for the specified date (ISO 8601 format, UTC.)
Examples:
&for_date=2025-05-15
Filter by date.
Returns items after and including the specified date (ISO 8601 format, UTC.)
Examples:
&for_date_after=2025-05-15
Filter by date.
Returns items on or before the specified date (ISO 8601 format, UTC.)
Examples:
&for_date_before=2025-05-15
Number of results to return per page. Maximum is 100. Default is 20.
Filter by metric code. Case-insensitive. Supports partial matches.
Filter by metric ID. Can be multiple.
The initial index from which to return the results.
Ordering of the results.
For ascending sort order use field.asc, for descending sort order use field.desc.
For sorting by multiple parameters write them as comma separated string: client_id.asc,id.desc.
Final stable tiebreak ordering is added except when pk sorting used.
addendum_id.asc- Addendum idaddendum_id.desc- Addendum id (descending)period_range_start.asc- Period range startperiod_range_start.desc- Period range start (descending)period_range_end.asc- Period range endperiod_range_end.desc- Period range end (descending)calc_rule_type.asc- Calc rule typecalc_rule_type.desc- Calc rule type (descending)created_at.asc- Created atcreated_at.desc- Created at (descending)currency_id.asc- Currency idcurrency_id.desc- Currency id (descending)feature_name.asc- Feature namefeature_name.desc- Feature name (descending)for_date.asc- For datefor_date.desc- For date (descending)id.asc- Idid.desc- Id (descending)money_value.asc- Money valuemoney_value.desc- Money value (descending)plan_item_id.asc- Plan item idplan_item_id.desc- Plan item id (descending)product_name.asc- Product nameproduct_name.desc- Product name (descending)product_id.asc- Product idproduct_id.desc- Product id (descending)tax_rate.asc- Tax ratetax_rate.desc- Tax rate (descending)region_id.asc- Region idregion_id.desc- Region id (descending)region_name.asc- Region nameregion_name.desc- Region name (descending)
addendum_id.asc, addendum_id.desc, calc_rule_type.asc, calc_rule_type.desc, created_at.asc, created_at.desc, currency_id.asc, currency_id.desc, feature_name.asc, feature_name.desc, for_date.asc, for_date.desc, id.asc, id.desc, money_value.asc, money_value.desc, period_range_end.asc, period_range_end.desc, period_range_start.asc, period_range_start.desc, plan_item_id.asc, plan_item_id.desc, product_id.asc, product_id.desc, product_name.asc, product_name.desc, region_id.asc, region_id.desc, region_name.asc, region_name.desc, tax_rate.asc, tax_rate.desc Ordering of the results.
This field is left for compatibility and can be deprecated in future versions. Use order_by instead.
Default sort order is ascending. Put - before value for descending sort order: -id.
For sorting by multiple parameters write them as comma separated string: -client_id,id.
Final stable tiebreak ordering is added except when pk sorting used.
addendum_id- Addendum id-addendum_id- Addendum id (descending)period_range_start- Period range start-period_range_start- Period range start (descending)period_range_end- Period range end-period_range_end- Period range end (descending)calc_rule_type- Calc rule type-calc_rule_type- Calc rule type (descending)created_at- Created at-created_at- Created at (descending)currency_id- Currency id-currency_id- Currency id (descending)feature_name- Feature name-feature_name- Feature name (descending)for_date- For date-for_date- For date (descending)id- Id-id- Id (descending)money_value- Money value-money_value- Money value (descending)plan_item_id- Plan item id-plan_item_id- Plan item id (descending)product_name- Product name-product_name- Product name (descending)product_id- Product id-product_id- Product id (descending)tax_rate- Tax rate-tax_rate- Tax rate (descending)region_id- Region id-region_id- Region id (descending)region_name- Region name-region_name- Region name (descending)
-addendum_id, -calc_rule_type, -created_at, -currency_id, -feature_name, -for_date, -id, -money_value, -period_range_end, -period_range_start, -plan_item_id, -product_id, -product_name, -region_id, -region_name, -tax_rate, addendum_id, calc_rule_type, created_at, currency_id, feature_name, for_date, id, money_value, period_range_end, period_range_start, plan_item_id, product_id, product_name, region_id, region_name, tax_rate Filter by payer ID. Can be multiple.
Filter by period range.
Returns items with a period containing the specified date-time (ISO 8601/RFC 3339 format, UTC.)
You can specify a date with a time separated by a space.
Examples:
&period_contains=2025-05-15 12:00:00&period_contains=2025-05-15T12:00:00Z
Filter by period range.
Returns items with a period ending before the specified date-time (ISO 8601/RFC 3339 format, UTC.)
You can specify a date with a time separated by a space.
Examples:
&period_ends_before=2025-05-15 12:00:00&period_ends_before=2025-05-15T12:00:00Z
Filter by period range.
Returns items excluding those with a period containing the specified date-time (ISO 8601/RFC 3339 format, UTC.)
You can specify a date with a time separated by a space.
Examples:
&period_outside=2025-05-15 12:00:00&period_outside=2025-05-15T12:00:00Z
Filter by period range.
Returns items with a period beginning after the specified date-time (ISO 8601/RFC 3339 format, UTC.)
You can specify a date with a time separated by a space.
Examples:
&period_starts_after=2025-05-15 12:00:00&period_starts_after=2025-05-15T12:00:00Z
Filter by plan ID. Can be multiple.
Filter by plan name. Case insensitive. Supports partial matches.
Filter by Product Category ID. Can be multiple.
Filter by product category name. Case insensitive. Supports partial matches.
Filter by product ID. Can be multiple.
Returns products with the specified ID.
Examples:
&product_id=1&product_id=1&product_id=2
Available values:
1- CDN2- Object Storage3- Web Security4- Streaming5- Cloud6- Colocation Services7- WG Private Cloud8- p2p9- DDoS Protection10- Managed DNS11- Other Services12- Premium Support13- Connectivity14- Hosting (G-Hosting)15- Managed Services16- Rent17- Software development18- VM Ware19- LaaS20- AWS Cloud21- FastEdge22- Technical Support23- WAAP25- Edge Proxy32- AI Managed Dedicated Compute65- Gclaw
Filter by product internal name. Can be multiple.
Returns products with the specified internal name.
Examples:
&product_internal_name=CDN&product_internal_name=CDN&product_internal_name=DNS
Available values:
AI_DEDCOMP- AI Managed Dedicated ComputeAWS_CLOUD- AWS CloudCDN- CDNCLOUD- CloudCONNECT- Colocation ServicesCONNECTIVITY- ConnectivityDDOS- Web SecurityDNS- Managed DNSFAST_EDGE- FastEdgeGCLAW- GclawGHOST- Hosting (G-Hosting)INFRASTRUCTURE_PROTECTION- DDoS ProtectionLAAS- LaaSMANAGED_SERVICES- Managed ServicesOTHER_SERVICES- Other ServicesP2P- p2pPREMIUM_SUPPORT- Premium SupportRENT- RentSHIELD_PROXY- Edge ProxySOFTWARE_DEVELOPMENT- Software developmentSTORAGE- Object StorageSTREAMING- StreamingTECHNICAL_SUPPORT- Technical SupportVMWARE- VM WareWAAP- WAAPWG_PRIVATE_CLOUD- WG Private Cloud
Filter by product name. Case insensitive. Supports partial matches.
Filter by region ID. Can be multiple.
Filter by region internal name. Can be multiple.
Filter by region name. Case insensitive. Supports partial matches.
Filter expenses by associated subscription IDs.